function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

import hoistNonReactStatics from 'hoist-non-react-statics';
import React, { useContext } from 'react';
import { jsx as _jsx } from "react/jsx-runtime";
export const DesignTokenContext = /*#__PURE__*/React.createContext({});
export const useDesignTokens = () => useContext(DesignTokenContext);
export default ((options = {}) => ({
  name: '@modern-js/plugin-design-token',
  setup: () => ({
    hoc({
      App
    }, next) {
      const DesignTokenAppWrapper = props => {
        const {
          token = {},
          useStyledComponentsThemeProvider = false,
          useDesignTokenContext = false
        } = options;

        if (useStyledComponentsThemeProvider && useDesignTokenContext) {
          const {
            ThemeProvider
          } = require('@modern-js/runtime-core/styled');

          return /*#__PURE__*/_jsx(ThemeProvider, {
            theme: token,
            children: /*#__PURE__*/_jsx(DesignTokenContext.Provider, {
              value: token,
              children: /*#__PURE__*/_jsx(App, _objectSpread({}, props))
            })
          });
        } else if (useStyledComponentsThemeProvider) {
          const {
            ThemeProvider
          } = require('@modern-js/runtime-core/styled');

          return /*#__PURE__*/_jsx(ThemeProvider, {
            theme: token,
            children: /*#__PURE__*/_jsx(App, _objectSpread({}, props))
          });
        } else if (useDesignTokenContext) {
          return /*#__PURE__*/_jsx(DesignTokenContext.Provider, {
            value: token,
            children: /*#__PURE__*/_jsx(App, _objectSpread({}, props))
          });
        } else {
          return /*#__PURE__*/_jsx(App, _objectSpread({}, props));
        }
      };

      return next({
        App: hoistNonReactStatics(DesignTokenAppWrapper, App)
      });
    }

  })
}));